Search.setIndex({"docnames": ["api", "api/crypto", "api/ssl", "backward-compatibility", "changelog", "index", "install", "internals", "introduction"], "filenames": ["api.rst", "api/crypto.rst", "api/ssl.rst", "backward-compatibility.rst", "changelog.rst", "index.rst", "install.rst", "internals.rst", "introduction.rst"], "titles": ["<code class=\"xref py py-mod docutils literal notranslate\"><span class=\"pre\">OpenSSL</span></code> \u2014 Python interface to OpenSSL", "<code class=\"xref py py-mod docutils literal notranslate\"><span class=\"pre\">crypto</span></code> \u2014 Generic cryptographic module", "<code class=\"xref py py-mod docutils literal notranslate\"><span class=\"pre\">SSL</span></code> \u2014 An interface to the SSL-specific parts of OpenSSL", "Backward Compatibility", "Changelog", "Welcome to pyOpenSSL\u2019s documentation!", "Installation", "Internals", "Introduction"], "terms": {"This": [0, 1, 2, 4, 7, 8], "package": [0, 4], "provides": 0, "high": 0, "level": [0, 7, 8], "functions": [0, 1, 4, 7, 8], "library": [0, 2, 4, 5, 6, 8], "The": [0, 1, 2, 4, 6, 7, 8], "following": [0, 1, 2, 8], "modules": 0, "defined": [0, 2], "crypto": [0, 4, 5, 8], "generic": [0, 5, 8], "cryptographic": [0, 5], "module": [0, 2, 4, 5, 7, 8], "elliptic": [0, 2], "curves": 0, "serialization": 0, "deserialization": 0, "signing": 0, "verifying": [0, 4], "signatures": [0, 4], "x509": [0, 4], "objects": [0, 4, 7], "x509name": [0, 4], "x509req": [0, 4], "x509store": [0, 4], "x509storecontexterror": [0, 4], "x509storecontext": [0, 4], "x509storeflags": [0, 4], "constants": [0, 2, 4], "pkey": [0, 4, 8], "x509extension": [0, 4], "crl": [0, 4], "revoked": [0, 4], "exceptions": [0, 2, 4, 5], "digest": [0, 4], "names": [0, 2, 4], "ssl": [0, 4, 5, 7, 8], "an": [0, 4, 5, 7, 8], "specific": [0, 4, 5, 7, 8], "parts": [0, 5, 7], "tls_method": [0, 2], "tls_server_method": [0, 2], "tls_client_method": [0, 2], "sslv2_method": [0, 2], "sslv3_method": [0, 2], "sslv23_method": [0, 2], "tlsv1_method": [0, 2], "tlsv1_1_method": [0, 2], "tlsv1_2_method": [0, 2], "ssl3_version": [0, 2], "tls1_version": [0, 2], "tls1_1_version": [0, 2], "tls1_2_version": [0, 2], "tls1_3_version": [0, 2], "verify_none": [0, 2], "verify_peer": [0, 2], "verify_fail_if_no_peer_cert": [0, 2], "filetype_pem": [0, 1, 2, 8], "filetype_asn1": [0, 1, 2, 8], "op_single_dh_use": [0, 2], "op_single_ecdh_use": [0, 2], "op_ephemeral_rsa": [0, 2], "op_no_ticket": [0, 2], "op_no_compression": [0, 2], "op_no_sslv2": [0, 2], "op_no_sslv3": [0, 2], "op_no_tlsv1": [0, 2], "op_no_tlsv1_1": [0, 2], "op_no_tlsv1_2": [0, 2], "op_no_tlsv1_3": [0, 2], "openssl_version": [0, 2, 4], "openssl_cflags": [0, 2], "openssl_built_on": [0, 2], "openssl_platform": [0, 2], "openssl_dir": [0, 2], "sess_cache_off": [0, 2], "sess_cache_client": [0, 2], "sess_cache_server": [0, 2], "sess_cache_both": [0, 2], "sess_cache_no_auto_clear": [0, 2], "sess_cache_no_internal_lookup": [0, 2], "sess_cache_no_internal_store": [0, 2], "sess_cache_no_internal": [0, 2], "openssl_version_number": [0, 2], "no_overlapping_protocols": [0, 2, 4], "contexttype": [0, 2, 4], "connectiontype": [0, 2, 4], "error": [0, 1, 2, 4, 7, 8], "zeroreturnerror": [0, 2, 7], "wantreaderror": [0, 2, 7], "wantwriteerror": [0, 2, 7], "wantx509lookuperror": [0, 2, 7], "syscallerror": [0, 2, 7], "context": [0, 4], "session": 0, "connection": [0, 4, 7], "pyca": [1, 4, 8], "cryptography": [1, 4, 6, 8], "likely": [1, 6], "better": 1, "choice": [1, 8], "than": [1, 4, 5], "using": [1, 2, 4, 6, 7], "It": [1, 2, 4], "contains": [1, 6], "complete": [1, 2, 4], "set": [1, 4], "primitives": [1, 4], "well": [1, 8], "significantly": [1, 4], "more": [1, 2, 4, 5, 7, 8], "powerful": 1, "api": [1, 2, 7, 8], "If": [1, 2, 3, 4, 6, 7, 8], "necessary": [1, 7], "you": [1, 2, 3, 4, 6, 7, 8], "can": [1, 2, 4, 6, 7, 8], "convert": 1, "from": [1, 2, 4, 6, 7, 8], "to_cryptography": [1, 4], "from_cryptography": [1, 4], "methods": [1, 2, 4, 5, 8], "take": [1, 6, 8], "one": [1, 2, 7, 8], "determine": [1, 4], "format": 1, "openssl": [1, 4, 5, 7, 8], "serializes": 1, "data": [1, 2, 4, 8], "base64": 1, "encoded": 1, "representation": 1, "underlying": [1, 2, 4, 7], "asn": 1, "1": [1, 2, 5, 6, 8], "structure": 1, "includes": 1, "delimiters": 1, "define": 1, "what": [1, 2, 5, 7, 8], "contained": [1, 8], "within": 1, "block": 1, "example": [1, 8], "begin": 1, "end": [1, 2], "used": [1, 2, 4, 7], "also": [1, 2, 4, 7, 8], "sometimes": 1, "referred": 1, "der": 1, "type_rsa": 1, "type_dsa": 1, "key": [1, 2, 4, 8], "type": [1, 2, 4, 8], "exception": [1, 2, 4], "several": 1, "name": [1, 4], "These": [1, 2, 8], "must": [1, 4, 8], "strings": [1, 2, 4, 7], "describing": [1, 2, 8], "algorithm": 1, "supported": [1, 4, 5], "evp_get_digestbyname": 1, "specifically": [1, 4], "For": [1, 2, 4, 7], "b": [1, 4], "sha256": 1, "sha384": 1, "information": [1, 2, 4, 7, 8], "list": [1, 2, 4, 8], "found": [1, 8], "evp_digestinit": 1, "3": [1, 2, 6, 8], "man": [1, 2], "page": [1, 2, 5], "your": [1, 4, 8], "installation": [1, 5], "online": 1, "latest": 1, "version": [1, 2, 4, 7, 8], "https": [1, 8], "www": 1, "org": 1, "docs": 1, "manmaster": 1, "man3": 1, "html": [1, 6], "handles": [2, 4], "things": [2, 7, 8], "There": 2, "two": 2, "represent": [2, 4], "different": [2, 7, 8], "use": [2, 4, 7, 8], "when": [2, 4, 7, 8], "creating": 2, "object": [2, 4, 5, 7], "new": [2, 4, 5, 8], "code": [2, 4, 7], "should": [2, 4, 7, 8], "only": [2, 4, 7, 8], "build": 2, "missing": 2, "support": [2, 4, 8], "any": [2, 4, 6, 7, 8], "protocols": 2, "constructing": 2, "corresponding": [2, 5], "_method": 2, "raise": [2, 4], "tls": [2, 4, 8], "versions": [2, 4, 5, 8], "setting": [2, 4], "minimum": [2, 4], "maximum": [2, 4], "verification": [2, 4], "mode": 2, "s": [2, 4, 6, 7, 8], "set_verify": [2, 4], "method": [2, 7, 8], "file": [2, 4, 7, 8], "use_certificate_file": 2, "use_privatekey_file": 2, "set_options": 2, "options": 2, "always": [2, 4, 6], "created": [2, 8], "ephemeral": 2, "curve": 2, "diffie": 2, "hellman": 2, "constant": [2, 4], "option": 2, "rsa": 2, "keys": [2, 4], "doing": 2, "operations": 2, "ticket": 2, "extension": 2, "compression": 2, "each": 2, "disables": 2, "protocol": [2, 4], "interesting": 2, "re": [2, 4, 7, 8], "e": [2, 6, 7, 8], "g": 2, "get": [2, 4, 7], "sslv2": [2, 4], "compatible": [2, 4], "handshake": [2, 4], "don": [2, 8], "t": [2, 3, 4, 7, 8], "want": [2, 7], "op_no_": 2, "may": [2, 4], "undefined": 2, "changed": [2, 4], "22": 2, "0": [2, 6], "previously": [2, 8], "were": [2, 4, 7, 8], "all": [2, 4, 7, 8], "named": 2, "ssleay_": [2, 4], "those": [2, 7, 8], "still": 2, "available": [2, 4], "backwards": 2, "compatibility": [2, 4, 5], "openssl_": [2, 4], "preferred": [2, 8], "specify": 2, "retrieve": [2, 4], "see": [2, 4, 7], "c": [2, 7], "details": [2, 7], "set_session_cache_mode": 2, "behavior": [2, 3, 8], "cache": 2, "potential": [2, 4], "reuse": 2, "ssl_ctx_set_session_cache_mode": 2, "14": [2, 6], "integer": 2, "giving": 2, "number": [2, 4], "pyopenssl": [2, 3, 4, 6, 7, 8], "ssleay_version": [2, 4], "A": 2, "sentinel": [2, 4], "value": [2, 4], "returned": 2, "callback": [2, 4], "passed": [2, 7], "set_alpn_select_callback": [2, 4], "indicate": 2, "continue": 2, "without": [2, 4], "application": [2, 4], "19": 2, "class": [2, 7, 8], "socket": [2, 4, 5], "representing": 2, "connections": 2, "instance": 2, "none": [2, 4], "case": 2, "memory": [2, 4], "bio": 2, "bio_read": 2, "bio_write": 2, "bio_shutdown": 2, "base": 2, "other": [2, 4, 7, 8], "related": 2, "raised": [2, 7], "directly": 2, "whenever": [2, 8], "has": [2, 3, 4, 7, 8], "messages": 2, "queue": 2, "where": [2, 4], "item": 2, "tuple": 2, "lib": 2, "function": [2, 4, 5, 7, 8], "reason": 2, "here": [2, 7], "problem": [2, 7], "err": 2, "matches": 2, "return": [2, 4, 8], "ssl_error_zero_return": 2, "been": [2, 4], "closed": 2, "In": [2, 4], "occurs": 2, "closure": 2, "alert": 2, "occurred": 2, "i": [2, 7], "cleanly": 2, "note": [2, 4, 8], "does": [2, 4, 6, 8], "necessarily": 2, "mean": [2, 5], "transport": [2, 7], "layer": 2, "seem": 2, "little": 2, "strange": 2, "match": 2, "ssl_error": 2, "very": [2, 3, 4, 8], "convenient": 2, "operation": 2, "did": 2, "same": [2, 4, 6], "o": [2, 7], "called": [2, 4, 7, 8], "again": 2, "later": [2, 4, 8], "arguments": [2, 4], "lead": 2, "since": [2, 4, 7, 8], "handshakes": 2, "occur": 2, "time": [2, 4, 6, 8], "wanted": 2, "read": [2, 6, 7], "dirty": 2, "sent": 2, "over": [2, 8], "network": [2, 4], "clean": 2, "inside": 2, "tunnel": 2, "based": [2, 4], "means": [2, 6], "coming": 2, "us": [2, 4, 7, 8], "until": [2, 4], "succeeds": 2, "attempted": 2, "recv": [2, 4], "send": [2, 4, 8], "do_handshake": 2, "prevented": 2, "incomplete": 2, "probably": [2, 7], "select": 2, "before": [2, 4, 8], "trying": 2, "buffer": [2, 4, 8], "too": [2, 7], "full": [2, 4, 8], "write": [2, 4, 7, 8], "because": [2, 6, 8], "asked": 2, "won": 2, "callbacks": [2, 5], "contain": 2, "violates": 2, "parameter": [2, 4], "pair": 2, "errnum": 2, "errstr": 2, "have": [2, 4, 7, 8], "footnotes": 2, "actually": [2, 4, 8], "required": 2, "behaves": 2, "like": [2, 7, 8], "could": [2, 4], "even": 2, "files": [2, 4, 8], "though": [2, 8], "d": 2, "tricky": 2, "right": 2, "strong": 3, "policy": [3, 4], "generally": 3, "speaking": 3, "shouldn": [3, 7], "ever": 3, "afraid": 3, "updating": 3, "breaking": [3, 8], "changes": [3, 7, 8], "needed": 3, "do": [3, 5, 7, 8], "done": [3, 4], "announced": 3, "changelog": [3, 5, 8], "old": 3, "raises": [3, 4], "deprecationwarning": 3, "year": [3, 4], "another": 3, "announcement": 3, "strict": 4, "third": 4, "digit": 4, "regressions": 4, "fixed": 4, "remove": 4, "sphinx": [4, 6, 8], "restructured": 4, "text": 4, "deprecated": 4, "load_certificate_request": 4, "dump_certificate_request": 4, "instead": [4, 7, 8], "certificatesigningrequest": 4, "certificatesigningrequestbuilder": 4, "load_der_x509_csr": 4, "load_pem_x509_csr": 4, "added": [4, 8], "hints": [4, 8], "1308": 4, "from_cryptography_key": 4, "accept": [4, 7], "public": [4, 8], "private": [4, 8], "ec": 4, "ed25519": 4, "ed448": 4, "1310": 4, "removed": 4, "pkcs12": 4, "netscapespki": 4, "replaced": 4, "pkcs": 4, "apis": 4, "get_selected_srtp_profile": 4, "which": [4, 8], "srtp": 4, "profile": 4, "negotiated": 4, "1279": 4, "dropped": 4, "python": [4, 5, 6, 7, 8], "6": 4, "now": [4, 7], "41": 4, "load_pkcs7": 4, "load_pkcs12": 4, "had": 4, "years": 4, "op_legacy_server_connect": 4, "allow": [4, 7], "legacy": 4, "insecure": 4, "renegotiation": 4, "between": 4, "unpatched": 4, "servers": 4, "1234": 4, "intended": 4, "load_crl": 4, "dump_crl": 4, "sign": 4, "verify": 4, "add_crl": 4, "certificaterevocationlist": 4, "addition": 4, "test_set_default_verify_paths": 4, "test": [4, 6, 8], "so": [4, 7], "skipped": 4, "notify_policy": 4, "1213": 4, "increased": 4, "x": 4, "invalid": 4, "rejected": 4, "set_version": 4, "x509verificationcodes": 4, "1202": 4, "worked": 4, "around": [4, 5, 8], "issue": [4, 8], "caused": 4, "get_short_name": 4, "short": [4, 8], "known": 4, "1204": 4, "40": 4, "add": [4, 8], "dtlsv1_get_timeout": 4, "dtlsv1_handle_timeout": 4, "dtls": 4, "timeouts": 4, "1180": 4, "partial_chain": 4, "users": 4, "perform": [4, 8], "certificate": 4, "partial": 4, "chains": 4, "1166": 4, "39": 4, "sslv3": 4, "38": 4, "we": [4, 5, 6, 7, 8], "pin": 4, "releases": [4, 6], "against": 4, "major": 4, "prevent": 4, "future": [4, 7], "breakage": 4, "refactored": 4, "changing": 4, "its": [4, 8], "internal": 4, "attributes": 4, "1133": 4, "favor": 4, "get_verify_mode": 4, "override": 4, "flags": 4, "1073": 4, "use_certificate": 4, "use_privatekey": 4, "per": 4, "just": 4, "1121": 4, "drop": 4, "7": [4, 8], "1047": 4, "35": 4, "expose": 4, "wrappers": [4, 8], "some": [4, 7], "1026": 4, "alpn": 4, "993": 4, "set_min_proto_version": 4, "set_max_proto_version": 4, "985": 4, "updated": 4, "upcoming": 4, "release": [4, 5], "raising": 4, "deprecation": 4, "warnings": 4, "1030": 4, "tsafe": 4, "set_npn_advertise_callback": 4, "set_npn_select_callback": 4, "get_next_proto_negotiated": 4, "optional": 4, "chain": 4, "additional": 4, "untrusted": 4, "certificates": 4, "specified": 4, "help": [4, 6], "building": 4, "948": 4, "load_locations": 4, "trusted": 4, "bundles": 4, "directories": 4, "943": 4, "set_keylog_callback": 4, "log": 4, "material": 4, "910": 4, "get_verified_chain": 4, "verified": 4, "peer": 4, "894": 4, "make": [4, 6, 8], "omitted": 4, "default": [4, 8], "933": 4, "bug": 4, "truncate": 4, "cause": 4, "zero": 4, "length": 4, "due": 4, "null": 4, "byte": 4, "passphrase": 4, "load_privatekey": 4, "dump_privatekey": 4, "947": 4, "pkeytype": 4, "x509nametype": 4, "x509reqtype": 4, "x509type": 4, "x509storetype": 4, "crltype": 4, "pkcs7type": 4, "pkcs12type": 4, "netscapespkitype": 4, "aliases": 4, "classes": 4, "suffix": 4, "814": 4, "8": [4, 8], "issues": 4, "macos": 4, "transitive": 4, "dependency": 4, "875": 4, "820": 4, "bytearray": 4, "cffi": [4, 7], "from_buffer": 4, "852": 4, "add_cert": 4, "longer": [4, 7], "duplicate": 4, "cert": 4, "787": 4, "works": [4, 7], "805": 4, "nul": 4, "bytes": [4, 8], "get_components": 4, "804": 4, "get_certificate": 4, "local": 4, "733": 4, "sets": 4, "ssl_mode_auto_retry": 4, "753": 4, "set_tlsext_use_srtp": 4, "enable": 4, "negotiation": 4, "keying": 4, "734": 4, "after": 4, "free": [4, 8], "resolved": 4, "leak": 4, "loading": 4, "cacerts": 4, "723": 4, "export_keying_material": 4, "rfc": 4, "5705": 4, "export": 4, "725": 4, "subset": [4, 5], "rand": 4, "allows": 4, "conscientious": 4, "reseed": 4, "csprng": 4, "fork": 4, "708": 4, "corrected": 4, "reusing": 4, "issuer": 4, "subject": 4, "mutated": 4, "709": 4, "677": 4, "being": [4, 6, 7], "ahead": 4, "our": [4, 8], "normal": 4, "schedule": 4, "lack": 4, "fact": 4, "becoming": 4, "maintenance": 4, "burden": 4, "os": 4, "urandom": 4, "675": 4, "673": 4, "690": 4, "691": 4, "callers": 4, "658": 4, "causing": 4, "set_default_verify_paths": 4, "work": [4, 8], "manylinux1": 4, "wheels": 4, "665": 4, "crash": 4, "dsa": 4, "cases": 4, "670": 4, "egd": 4, "applications": 4, "prefer": [4, 8], "random": 4, "generation": 4, "630": 4, "argument": 4, "pass": [4, 7], "explicit": 4, "652": 4, "asn1_time": 4, "casting": 4, "set_notbefore": 4, "set_notafter": 4, "set_rev_date": 4, "set_nextupdate": 4, "set_lastupdate": 4, "times": 4, "form": [4, 8], "yyyymmddhhmmssz": 4, "yyyymmddhhmmss": 4, "hhmm": 4, "612": 4, "x509extensiontype": 4, "converting": [4, 7], "509": 4, "640": 4, "csrs": 4, "crls": 4, "645": 4, "debug": [4, 6], "overview": 4, "including": 4, "linked": [4, 6], "useful": 4, "runtime": 4, "m": [4, 6], "620": 4, "fallback": 4, "path": 4, "accommodate": 4, "633": 4, "set_time": 4, "custom": 4, "567": 4, "collection": 4, "working": 4, "ocsp": 4, "stapling": 4, "possible": [4, 8], "validate": 4, "assertions": 4, "staple": 4, "them": [4, 6, 7, 8], "stapled": 4, "assertion": 4, "provided": 4, "need": [4, 8], "own": 4, "handle": 4, "set_ocsp_server_callback": 4, "set_ocsp_client_callback": 4, "request_ocsp": 4, "580": 4, "allocation": 4, "avoid": 4, "zeroing": 4, "allocates": 4, "unnecessary": 4, "reduces": 4, "cpu": 4, "usage": 4, "amount": 4, "proportional": 4, "size": 4, "process": [4, 8], "lot": [4, 5, 7], "lage": 4, "allocations": 4, "provide": 4, "considerable": 4, "performance": 4, "improvements": 4, "578": 4, "automatically": 4, "ssl_ctx_set_ecdh_auto": 4, "575": 4, "fix": [4, 8], "empty": 4, "581": 4, "errors": [4, 6], "failures": 4, "subinterpreters": 4, "embedded": 4, "pythons": 4, "552": 4, "9": 4, "filetype_text": 4, "496": 4, "483": 4, "constructed": 4, "exported": 4, "439": 4, "newer": 4, "opaque": 4, "structs": 4, "first": [4, 8], "under": 4, "stewardship": 4, "made": 4, "many": 4, "development": [4, 5], "pleasing": 4, "suite": 4, "passes": 4, "both": 4, "linux": 4, "moved": 4, "pytest": 4, "ci": [4, 8], "runs": 4, "part": 4, "tox": 4, "source": 4, "fully": 4, "flake8": 4, "compliant": 4, "hope": 4, "lowered": 4, "barrier": 4, "contributions": 4, "open": 4, "hear": 4, "about": [4, 7], "remaining": 4, "frustrations": 4, "never": [4, 8], "significant": 4, "real": 4, "world": 4, "main": [4, 7, 8], "affected": 4, "upgrade": 4, "uses": 4, "seed": 4, "prng": 4, "please": [4, 6, 8], "1636": 4, "background": 4, "decision": 4, "accordance": 4, "sooner": 4, "secure": 4, "needs": 4, "2015": 4, "table": 4, "dropping": 4, "once": 4, "set_session_id": 4, "renegotiate": 4, "renegotiate_pending": 4, "load_client_ca": 4, "They": [4, 8], "lacking": 4, "implementation": 4, "422": 4, "segmentation": 4, "fault": 4, "larger": 4, "4096": 4, "bit": 4, "428": 4, "attributeerror": 4, "get_app_data": 4, "app": 4, "304": 4, "dump_publickey": [4, 8], "dump": [4, 8], "load_publickey": 4, "load": 4, "serialized": 4, "representations": 4, "382": 4, "revocation": 4, "out": [4, 6, 8], "string": 4, "368": 4, "get_state_string": 4, "binding": 4, "state_string_long": 4, "358": 4, "msg_peek": 4, "flag": 4, "recv_into": 4, "294": 4, "get_protocol_version": 4, "get_protocol_version_name": 4, "244": 4, "switched": [4, 7], "utf8string": 4, "mask": 4, "formerly": 4, "defaulted": 4, "t61string": 4, "utf": 4, "characters": 4, "present": 4, "config": 4, "2005": 4, "actual": 4, "didn": 4, "change": 4, "late": 4, "last": 4, "To": [4, 6], "revert": 4, "call": 4, "_lib": 4, "asn1_string_set_default_mask_asc": 4, "234": 4, "preserved": 4, "repository": [4, 8], "v": 5, "24": 5, "2": [5, 8], "rather": 5, "thin": 5, "wrapper": 5, "With": 5, "nothing": 5, "calling": 5, "introduction": 5, "history": [5, 7], "contributing": 5, "interface": [5, 7], "internals": 5, "accessing": 5, "backward": 5, "index": 5, "search": 5, "install": 6, "pip": 6, "installing": 6, "order": 6, "develop": 6, "move": 6, "root": 6, "directory": 6, "checkout": 6, "run": 6, "As": 6, "pure": [6, 8], "project": [6, 8], "That": 6, "encounter": 6, "kind": 6, "compiler": 6, "bugtracker": 6, "wrong": 6, "place": 6, "report": 6, "cannot": 6, "ask": [6, 8], "appropriate": 6, "most": [6, 7], "culprit": 6, "bindings": [6, 8], "supports": 6, "platforms": 6, "upstream": 6, "currently": 6, "find": [6, 7, 8], "running": 6, "written": [6, 7], "restructuredtext": [6, 8], "built": 6, "cd": 6, "doc": [6, 8], "ran": 7, "three": 7, "problems": 7, "developing": 7, "chapter": 7, "realized": 7, "early": 7, "would": [7, 8], "felt": 7, "natural": 7, "mimic": 7, "system": 7, "translating": 7, "naturally": 7, "gives": 7, "section": [7, 8], "having": [7, 8], "straightforward": 7, "originally": [7, 8], "existed": 7, "interested": 7, "descriptions": [7, 8], "control": 7, "document": [7, 8], "quickly": 7, "saw": 7, "benefit": 7, "wrapping": 7, "easy": 7, "transition": 7, "lacks": 7, "declared": 7, "static": 7, "approach": 7, "submodule": 7, "placing": 7, "socketmodule": 7, "obviously": 7, "good": [7, 8], "solution": 7, "might": 7, "import": 7, "tonnes": 7, "extra": 7, "stuff": 7, "going": 7, "importing": 7, "somehow": 7, "pointer": 7, "either": 7, "callable": 7, "really": 7, "lookups": 7, "involved": 7, "way": [7, 8], "supply": 7, "requirement": 7, "fileno": 7, "returns": 7, "descriptor": 7, "valid": 7, "calls": 7, "connect": 7, "apart": 7, "fail": [7, 8], "advanced": 7, "features": [7, 8], "entail": 7, "sort": 7, "bios": 7, "back": 7, "forth": 7, "expensive": 7, "unless": 7, "nice": 7, "able": 7, "reading": 7, "writing": 7, "becomes": 7, "virtually": 7, "useless": 7, "resolution": 7, "martin": 8, "sj\u00f6gren": 8, "standard": 8, "contemporary": 8, "begun": 8, "severely": 8, "limited": 8, "ways": 8, "maintained": 8, "jean": 8, "paul": 8, "calderone": 8, "who": 8, "among": 8, "managed": 8, "current": 8, "maintainers": 8, "grateful": 8, "improved": 8, "reaching": 8, "completeness": 8, "coverage": 8, "remains": 8, "featured": 8, "pypy": 8, "collaboratively": 8, "developed": 8, "authority": 8, "maintains": 8, "low": 8, "thank": 8, "interest": 8, "company": 8, "backing": 8, "therefore": 8, "dependent": 8, "community": 8, "welcome": 8, "github": 8, "tracker": 8, "come": 8, "extensive": 8, "how": 8, "reproduce": 8, "reporters": 8, "strongly": 8, "encouraged": 8, "include": 8, "self": 8, "correct": 8, "submitted": 8, "pull": 8, "requests": 8, "satisfy": 8, "properties": 8, "request": 8, "focus": 8, "particular": 8, "improvement": 8, "create": 8, "unrelated": 8, "bugfixes": 8, "follow": 8, "pep": 8, "especially": 8, "sense": 8, "naming": 8, "callables": 8, "introduce": 8, "untested": 8, "poorly": 8, "tested": 8, "touch": 8, "allowed": 8, "break": 8, "existing": 8, "tests": 8, "usually": 8, "comment": 8, "consider": 8, "progress": 8, "100": 8, "wrote": 8, "touched": 8, "causes": 8, "introducing": 8, "functionality": 8, "remember": 8, "docstring": 8, "parameters": 8, "takes": 8, "def": 8, "int": 8, "param": 8, "dumped": 8, "forget": 8, "auto": 8, "statement": 8, "relevant": 8, "py": 8, "prefixes": 8, "cross": 8, "linking": 8, "obj": 8, "types": 8, "func": 8, "meth": 8, "applicable": 8, "bugs": 8, "rst": 8, "entries": 8, "top": 8, "followed": 8, "line": 8, "some_func": 8, "something": 8, "awesome": 8, "com": 8, "_": 8, "semantic": 8, "newlines": 8, "ending": 8, "finally": 8, "reviewed": 8, "merging": 8, "mirrors": 8, "everyone": 8, "reviews": 8, "valuable": 8, "contribute": 8, "highly": 8, "merged": 8, "members": 8, "course": 8, "keep": 8, "requirements": 8, "detailed": 8, "merge": 8, "mind": 8, "final": 8, "responsibility": 8, "reviewing": 8, "lies": 8, "person": 8, "sensitive": 8, "perspective": 8, "reviewers": 8, "seriously": 8, "contribution": 8, "ll": 8, "hanging": 8, "dev": 8, "freenode": 8, "irc": 8, "questions": 8, "mailing": 8, "released": 8, "contributor": 8, "conduct": 8, "By": 8, "participating": 8, "agree": 8, "abide": 8, "terms": 8, "feel": 8, "discuss": 8, "gpg": 8, "encrypted": 8, "mail": 8, "maintainer": 8, "reached": 8, "hs": 8, "ox": 8, "cx": 8, "his": 8, "id": 8, "0xae2536227f69f181": 8, "fingerprint": 8, "c2a0": 8, "4f86": 8, "ace2": 8, "8adc": 8, "f817": 8, "dbb7": 8, "ae25": 8, "3622": 8, "7f69": 8, "f181": 8, "check": 8, "keybase": 8}, "objects": {"": [[0, 0, 0, "-", "OpenSSL"]], "OpenSSL": [[2, 0, 0, "-", "SSL"], [1, 0, 0, "-", "crypto"]], "OpenSSL.SSL": [[2, 1, 1, "", "ConnectionType"], [2, 1, 1, "", "ContextType"], [2, 2, 1, "", "Error"], [2, 1, 1, "", "FILETYPE_ASN1"], [2, 1, 1, "", "FILETYPE_PEM"], [2, 1, 1, "", "NO_OVERLAPPING_PROTOCOLS"], [2, 1, 1, "", "OPENSSL_BUILT_ON"], [2, 1, 1, "", "OPENSSL_CFLAGS"], [2, 1, 1, "", "OPENSSL_DIR"], [2, 1, 1, "", "OPENSSL_PLATFORM"], [2, 1, 1, "", "OPENSSL_VERSION"], [2, 1, 1, "", "OPENSSL_VERSION_NUMBER"], [2, 1, 1, "", "OP_EPHEMERAL_RSA"], [2, 1, 1, "", "OP_NO_COMPRESSION"], [2, 1, 1, "", "OP_NO_SSLv2"], [2, 1, 1, "", "OP_NO_SSLv3"], [2, 1, 1, "", "OP_NO_TICKET"], [2, 1, 1, "", "OP_NO_TLSv1"], [2, 1, 1, "", "OP_NO_TLSv1_1"], [2, 1, 1, "", "OP_NO_TLSv1_2"], [2, 1, 1, "", "OP_NO_TLSv1_3"], [2, 1, 1, "", "OP_SINGLE_DH_USE"], [2, 1, 1, "", "OP_SINGLE_ECDH_USE"], [2, 1, 1, "", "SESS_CACHE_BOTH"], [2, 1, 1, "", "SESS_CACHE_CLIENT"], [2, 1, 1, "", "SESS_CACHE_NO_AUTO_CLEAR"], [2, 1, 1, "", "SESS_CACHE_NO_INTERNAL"], [2, 1, 1, "", "SESS_CACHE_NO_INTERNAL_LOOKUP"], [2, 1, 1, "", "SESS_CACHE_NO_INTERNAL_STORE"], [2, 1, 1, "", "SESS_CACHE_OFF"], [2, 1, 1, "", "SESS_CACHE_SERVER"], [2, 1, 1, "", "SSL3_VERSION"], [2, 1, 1, "", "SSLv23_METHOD"], [2, 1, 1, "", "SSLv2_METHOD"], [2, 1, 1, "", "SSLv3_METHOD"], [2, 2, 1, "", "SysCallError"], [2, 1, 1, "", "TLS1_1_VERSION"], [2, 1, 1, "", "TLS1_2_VERSION"], [2, 1, 1, "", "TLS1_3_VERSION"], [2, 1, 1, "", "TLS1_VERSION"], [2, 1, 1, "", "TLS_CLIENT_METHOD"], [2, 1, 1, "", "TLS_METHOD"], [2, 1, 1, "", "TLS_SERVER_METHOD"], [2, 1, 1, "", "TLSv1_1_METHOD"], [2, 1, 1, "", "TLSv1_2_METHOD"], [2, 1, 1, "", "TLSv1_METHOD"], [2, 1, 1, "", "VERIFY_FAIL_IF_NO_PEER_CERT"], [2, 1, 1, "", "VERIFY_NONE"], [2, 1, 1, "", "VERIFY_PEER"], [2, 2, 1, "", "WantReadError"], [2, 2, 1, "", "WantWriteError"], [2, 2, 1, "", "WantX509LookupError"], [2, 2, 1, "", "ZeroReturnError"]], "OpenSSL.crypto": [[1, 2, 1, "", "Error"], [1, 1, 1, "", "FILETYPE_ASN1"], [1, 1, 1, "", "FILETYPE_PEM"], [1, 1, 1, "", "TYPE_DSA"], [1, 1, 1, "", "TYPE_RSA"]]}, "objtypes": {"0": "py:module", "1": "py:data", "2": "py:exception"}, "objnames": {"0": ["py", "module", "Python module"], "1": ["py", "data", "Python data"], "2": ["py", "exception", "Python exception"]}, "titleterms": {"openssl": [0, 2, 6], "python": 0, "interface": [0, 2], "crypto": 1, "generic": 1, "cryptographic": 1, "module": 1, "elliptic": 1, "curves": 1, "serialization": 1, "deserialization": 1, "certificates": 1, "certificate": 1, "signing": 1, "requests": 1, "private": 1, "keys": 1, "public": 1, "revocation": 1, "lists": 1, "verifying": 1, "signatures": 1, "x509": 1, "objects": [1, 2], "x509name": 1, "x509req": 1, "x509store": 1, "x509storecontexterror": 1, "x509storecontext": 1, "x509storeflags": 1, "constants": 1, "pkey": 1, "x509extension": 1, "crl": 1, "revoked": 1, "exceptions": [1, 7], "digest": 1, "names": 1, "ssl": 2, "an": 2, "specific": 2, "parts": 2, "context": 2, "session": 2, "connection": 2, "backward": [3, 4], "compatibility": 3, "changelog": 4, "24": 4, "2": 4, "1": 4, "2024": 4, "07": 4, "20": 4, "incompatible": 4, "changes": 4, "deprecations": 4, "0": 4, "03": 4, "09": 4, "01": 4, "22": 4, "23": 4, "3": 4, "2023": 4, "10": 4, "25": 4, "05": 4, "30": 4, "28": 4, "2022": 4, "29": 4, "21": 4, "2021": 4, "2020": 4, "12": 4, "15": 4, "11": 4, "27": 4, "19": 4, "2019": 4, "18": 4, "2018": 4, "16": 4, "17": 4, "5": 4, "2017": 4, "4": 4, "14": 4, "06": 4, "04": 4, "2016": 4, "08": 4, "26": 4, "older": 4, "entries": 4, "welcome": 5, "pyopenssl": 5, "s": 5, "documentation": [5, 6, 8], "contents": 5, "meta": 5, "indices": 5, "tables": 5, "installation": 6, "supported": 6, "versions": 6, "internals": 7, "callbacks": 7, "accessing": 7, "socket": 7, "methods": 7, "introduction": 8, "history": 8, "development": 8, "contributing": 8, "filing": 8, "bug": 8, "reports": 8, "patches": 8, "code": 8, "review": 8, "finding": 8, "help": 8, "security": 8}, "envversion": {"sphinx.domains.c": 3, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 9, "sphinx.domains.index": 1, "sphinx.domains.javascript": 3, "sphinx.domains.math": 2, "sphinx.domains.python": 4, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx.ext.intersphinx": 1, "sphinx": 60}, "alltitles": {"OpenSSL \u2014 Python interface to OpenSSL": [[0, "module-OpenSSL"]], "crypto \u2014 Generic cryptographic module": [[1, "module-OpenSSL.crypto"]], "Elliptic curves": [[1, "elliptic-curves"]], "Serialization and deserialization": [[1, "serialization-and-deserialization"]], "Certificates": [[1, "certificates"]], "Certificate signing requests": [[1, "certificate-signing-requests"]], "Private keys": [[1, "private-keys"]], "Public keys": [[1, "public-keys"]], "Certificate revocation lists": [[1, "certificate-revocation-lists"]], "Signing and verifying signatures": [[1, "signing-and-verifying-signatures"]], "X509 objects": [[1, "x509-objects"]], "X509Name objects": [[1, "x509name-objects"]], "X509Req objects": [[1, "x509req-objects"]], "X509Store objects": [[1, "x509store-objects"]], "X509StoreContextError objects": [[1, "x509storecontexterror-objects"]], "X509StoreContext objects": [[1, "x509storecontext-objects"]], "X509StoreFlags constants": [[1, "x509storeflags-constants"]], "PKey objects": [[1, "pkey-objects"]], "X509Extension objects": [[1, "x509extension-objects"]], "CRL objects": [[1, "crl-objects"]], "Revoked objects": [[1, "revoked-objects"]], "Exceptions": [[1, "exceptions"], [7, "exceptions"]], "Digest names": [[1, "digest-names"]], "SSL \u2014 An interface to the SSL-specific parts of OpenSSL": [[2, "module-OpenSSL.SSL"]], "Context objects": [[2, "context-objects"]], "Session objects": [[2, "session-objects"]], "Connection objects": [[2, "connection-objects"]], "Backward Compatibility": [[3, "backward-compatibility"]], "Changelog": [[4, "changelog"]], "24.2.1 (2024-07-20)": [[4, "id1"]], "Backward-incompatible changes:": [[4, "backward-incompatible-changes"], [4, "id3"], [4, "id9"], [4, "id13"], [4, "id18"], [4, "id23"], [4, "id29"], [4, "id34"], [4, "id39"], [4, "id44"], [4, "id51"], [4, "id57"], [4, "id64"], [4, "id68"], [4, "id78"], [4, "id86"], [4, "id93"], [4, "id100"], [4, "id106"], [4, "id112"], [4, "id121"], [4, "id128"], [4, "id139"], [4, "id148"], [4, "id153"], [4, "id160"]], "Deprecations:": [[4, "deprecations"], [4, "id4"], [4, "id10"], [4, "id14"], [4, "id20"], [4, "id25"], [4, "id30"], [4, "id35"], [4, "id40"], [4, "id46"], [4, "id53"], [4, "id58"], [4, "id65"], [4, "id69"], [4, "id81"], [4, "id88"], [4, "id94"], [4, "id101"], [4, "id107"], [4, "id115"], [4, "id122"], [4, "id132"], [4, "id140"], [4, "id149"], [4, "id154"], [4, "id161"]], "Changes:": [[4, "changes"], [4, "id5"], [4, "id11"], [4, "id15"], [4, "id21"], [4, "id26"], [4, "id31"], [4, "id36"], [4, "id41"], [4, "id47"], [4, "id54"], [4, "id59"], [4, "id66"], [4, "id70"], [4, "id83"], [4, "id89"], [4, "id95"], [4, "id102"], [4, "id108"], [4, "id117"], [4, "id124"], [4, "id133"], [4, "id141"], [4, "id150"], [4, "id155"], [4, "id162"]], "24.2.0 (2024-07-20)": [[4, "id2"]], "24.1.0 (2024-03-09)": [[4, "id8"]], "24.0.0 (2024-01-22)": [[4, "id12"]], "23.3.0 (2023-10-25)": [[4, "id17"]], "23.2.0 (2023-05-30)": [[4, "id22"]], "23.1.1 (2023-03-28)": [[4, "id28"]], "23.1.0 (2023-03-24)": [[4, "id33"]], "23.0.0 (2023-01-01)": [[4, "id38"]], "22.1.0 (2022-09-25)": [[4, "id43"]], "22.0.0 (2022-01-29)": [[4, "id50"]], "21.0.0 (2021-09-28)": [[4, "id56"]], "20.0.1 (2020-12-15)": [[4, "id63"]], "20.0.0 (2020-11-27)": [[4, "id67"]], "19.1.0 (2019-11-18)": [[4, "id77"]], "19.0.0 (2019-01-21)": [[4, "id85"]], "18.0.0 (2018-05-16)": [[4, "id92"]], "17.5.0 (2017-11-30)": [[4, "id99"]], "17.4.0 (2017-11-21)": [[4, "id105"]], "17.3.0 (2017-09-14)": [[4, "id111"]], "17.2.0 (2017-07-20)": [[4, "id120"]], "17.1.0 (2017-06-30)": [[4, "id127"]], "17.0.0 (2017-04-20)": [[4, "id138"]], "16.2.0 (2016-10-15)": [[4, "id147"]], "16.1.0 (2016-08-26)": [[4, "id152"]], "16.0.0 (2016-03-19)": [[4, "id159"]], "Older Changelog Entries": [[4, "older-changelog-entries"]], "Welcome to pyOpenSSL\u2019s documentation!": [[5, "welcome-to-pyopenssl-s-documentation"]], "Contents:": [[5, "contents"]], "Meta": [[5, "meta"]], "Indices and tables": [[5, "indices-and-tables"]], "Installation": [[6, "installation"]], "Supported OpenSSL Versions": [[6, "supported-openssl-versions"]], "Documentation": [[6, "documentation"], [8, "documentation"]], "Internals": [[7, "internals"]], "Callbacks": [[7, "callbacks"]], "Accessing Socket Methods": [[7, "accessing-socket-methods"]], "Introduction": [[8, "introduction"]], "History": [[8, "history"]], "Development": [[8, "development"]], "Contributing": [[8, "contributing"]], "Filing bug reports": [[8, "filing-bug-reports"]], "Patches": [[8, "patches"]], "Code": [[8, "code"]], "Review": [[8, "review"]], "Finding Help": [[8, "finding-help"]], "Security": [[8, "security"]]}, "indexentries": {"openssl": [[0, "module-OpenSSL"]], "module": [[0, "module-OpenSSL"], [1, "module-OpenSSL.crypto"], [2, "module-OpenSSL.SSL"]], "error": [[1, "OpenSSL.crypto.Error"], [2, "OpenSSL.SSL.Error"]], "filetype_asn1 (in module openssl.crypto)": [[1, "OpenSSL.crypto.FILETYPE_ASN1"]], "filetype_pem (in module openssl.crypto)": [[1, "OpenSSL.crypto.FILETYPE_PEM"]], "openssl.crypto": [[1, "module-OpenSSL.crypto"]], "type_dsa (in module openssl.crypto)": [[1, "OpenSSL.crypto.TYPE_DSA"]], "type_rsa (in module openssl.crypto)": [[1, "OpenSSL.crypto.TYPE_RSA"]], "connectiontype (in module openssl.ssl)": [[2, "OpenSSL.SSL.ConnectionType"]], "contexttype (in module openssl.ssl)": [[2, "OpenSSL.SSL.ContextType"]], "filetype_asn1 (in module openssl.ssl)": [[2, "OpenSSL.SSL.FILETYPE_ASN1"]], "filetype_pem (in module openssl.ssl)": [[2, "OpenSSL.SSL.FILETYPE_PEM"]], "no_overlapping_protocols (in module openssl.ssl)": [[2, "OpenSSL.SSL.NO_OVERLAPPING_PROTOCOLS"]], "openssl_built_on (in module openssl.ssl)": [[2, "OpenSSL.SSL.OPENSSL_BUILT_ON"]], "openssl_cflags (in module openssl.ssl)": [[2, "OpenSSL.SSL.OPENSSL_CFLAGS"]], "openssl_dir (in module openssl.ssl)": [[2, "OpenSSL.SSL.OPENSSL_DIR"]], "openssl_platform (in module openssl.ssl)": [[2, "OpenSSL.SSL.OPENSSL_PLATFORM"]], "openssl_version (in module openssl.ssl)": [[2, "OpenSSL.SSL.OPENSSL_VERSION"]], "openssl_version_number (in module openssl.ssl)": [[2, "OpenSSL.SSL.OPENSSL_VERSION_NUMBER"]], "op_ephemeral_rsa (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_EPHEMERAL_RSA"]], "op_no_compression (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_NO_COMPRESSION"]], "op_no_sslv2 (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_NO_SSLv2"]], "op_no_sslv3 (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_NO_SSLv3"]], "op_no_ticket (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_NO_TICKET"]], "op_no_tlsv1 (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_NO_TLSv1"]], "op_no_tlsv1_1 (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_NO_TLSv1_1"]], "op_no_tlsv1_2 (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_NO_TLSv1_2"]], "op_no_tlsv1_3 (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_NO_TLSv1_3"]], "op_single_dh_use (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_SINGLE_DH_USE"]], "op_single_ecdh_use (in module openssl.ssl)": [[2, "OpenSSL.SSL.OP_SINGLE_ECDH_USE"]], "openssl.ssl": [[2, "module-OpenSSL.SSL"]], "sess_cache_both (in module openssl.ssl)": [[2, "OpenSSL.SSL.SESS_CACHE_BOTH"]], "sess_cache_client (in module openssl.ssl)": [[2, "OpenSSL.SSL.SESS_CACHE_CLIENT"]], "sess_cache_no_auto_clear (in module openssl.ssl)": [[2, "OpenSSL.SSL.SESS_CACHE_NO_AUTO_CLEAR"]], "sess_cache_no_internal (in module openssl.ssl)": [[2, "OpenSSL.SSL.SESS_CACHE_NO_INTERNAL"]], "sess_cache_no_internal_lookup (in module openssl.ssl)": [[2, "OpenSSL.SSL.SESS_CACHE_NO_INTERNAL_LOOKUP"]], "sess_cache_no_internal_store (in module openssl.ssl)": [[2, "OpenSSL.SSL.SESS_CACHE_NO_INTERNAL_STORE"]], "sess_cache_off (in module openssl.ssl)": [[2, "OpenSSL.SSL.SESS_CACHE_OFF"]], "sess_cache_server (in module openssl.ssl)": [[2, "OpenSSL.SSL.SESS_CACHE_SERVER"]], "ssl3_version (in module openssl.ssl)": [[2, "OpenSSL.SSL.SSL3_VERSION"]], "sslv23_method (in module openssl.ssl)": [[2, "OpenSSL.SSL.SSLv23_METHOD"]], "sslv2_method (in module openssl.ssl)": [[2, "OpenSSL.SSL.SSLv2_METHOD"]], "sslv3_method (in module openssl.ssl)": [[2, "OpenSSL.SSL.SSLv3_METHOD"]], "syscallerror": [[2, "OpenSSL.SSL.SysCallError"]], "tls1_1_version (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLS1_1_VERSION"]], "tls1_2_version (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLS1_2_VERSION"]], "tls1_3_version (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLS1_3_VERSION"]], "tls1_version (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLS1_VERSION"]], "tls_client_method (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLS_CLIENT_METHOD"]], "tls_method (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLS_METHOD"]], "tls_server_method (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLS_SERVER_METHOD"]], "tlsv1_1_method (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLSv1_1_METHOD"]], "tlsv1_2_method (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLSv1_2_METHOD"]], "tlsv1_method (in module openssl.ssl)": [[2, "OpenSSL.SSL.TLSv1_METHOD"]], "verify_fail_if_no_peer_cert (in module openssl.ssl)": [[2, "OpenSSL.SSL.VERIFY_FAIL_IF_NO_PEER_CERT"]], "verify_none (in module openssl.ssl)": [[2, "OpenSSL.SSL.VERIFY_NONE"]], "verify_peer (in module openssl.ssl)": [[2, "OpenSSL.SSL.VERIFY_PEER"]], "wantreaderror": [[2, "OpenSSL.SSL.WantReadError"]], "wantwriteerror": [[2, "OpenSSL.SSL.WantWriteError"]], "wantx509lookuperror": [[2, "OpenSSL.SSL.WantX509LookupError"]], "zeroreturnerror": [[2, "OpenSSL.SSL.ZeroReturnError"]]}})